<ion-content class="ion-padding">
    <form on:submit|preventDefault={createUser} on:change={validate} on:ionChange={validate}>
        <ion-item>
            <ion-label position="floating">Email{#if invalidFields.email}<span class="failedValidationText">&nbsp;- {invalidFields.email}</span>{/if}</ion-label>
            <ion-input on:ionChange={(e) => user.email = e.currentTarget.value }></ion-input>
        </ion-item>
        <ion-item>
            <ion-label position="floating">First Name{#if invalidFields.firstName}<span class="failedValidationText">&nbsp;- {invalidFields.firstName}</span>{/if}</ion-label>
            <ion-input on:ionChange={(e) => user.firstName = e.currentTarget.value }></ion-input>
        </ion-item>
        <ion-item>
            <ion-label position="floating">Last Name{#if invalidFields.lastName}<span class="failedValidationText">&nbsp;- {invalidFields.lastName}</span>{/if}</ion-label>
            <ion-input on:ionChange={(e) => user.lastName = e.currentTarget.value }></ion-input>
        </ion-item>
        <ion-item>
            <ion-label position="floating">Role{#if invalidFields.role}<span class="failedValidationText">&nbsp;- {invalidFields.role}</span>{/if}</ion-label>
            <ion-select on:ionChange={(e) => user.role = e.currentTarget.value }>
                {#each Object.values(Role) as role}
                <ion-select-option value={role}>{role}</ion-select-option>
                {/each}
            </ion-select>
        </ion-item>
        <br>
        <br>
        <ion-button type="submit" expand="block">Create User</ion-button>
    </form>
</ion-content>


<script>
import {currentRoute} from 'svelte-grouter'
import {layoutStore} from '/client/LayoutStore'
import * as usersService from '/lib/UsersService'
import {Role} from '/lib/Roles'
import {presentToast} from '/client/ToastService'

$layoutStore.title = 'Create a User'
let invalidFields = {}, submitted = false

const user = {
    firstName: '',
    lastName: '',
    email: '',
    role: ''

}

function createUser() {
    submitted = true
    if (!validate()) return false 
    console.log('Creating a user')
    console.log(user);
    usersService.createUser(user)
    .then(() => {
        presentToast('User created')
    })
}
function validate() {
    if (submitted) {
        invalidFields = usersService.validate(user)
        if (Object.keys(invalidFields).length > 0 ) {
            return false
        }
    }
    return true
}
</script>

<style>

ion-select,ion-select-option,.select-text {
    text-transform: capitalize;
}
</style>